Open CASCADE Technology: Geom_ConicalSurface Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Geom_ConicalSurface Class Reference

Describes a cone. A cone is defined by the half-angle at its apex, and is positioned in space by a coordinate system (a gp_Ax3 object) and a reference radius as follows: More...

`#include <Geom_ConicalSurface.hxx>`

Inheritance diagram for Geom_ConicalSurface:
[legend]

## Public Member Functions
| Geom_ConicalSurface (const gp_Ax3 &A3, const Standard_Real Ang, const Standard_Real Radius)
| A3 defines the local coordinate system of the conical surface. Ang is the conical surface semi-angle ]0, PI/2[. Radius is the radius of the circle Viso in the placement plane of the conical surface defined with "XAxis" and "YAxis". The "ZDirection" of A3 defines the direction of the surface's axis of symmetry. If the location point of A3 is the apex of the surface Radius = 0 . At the creation the parametrization of the surface is defined such that the normal Vector (N = D1U ^ D1V) is oriented towards the "outside region" of the surface. More...
| Geom_ConicalSurface (const gp_Cone &C)
| Creates a ConicalSurface from a non transient Cone from package gp. More...
void | SetCone (const gp_Cone &C)
| Set <me> so that <me> has the same geometric properties as C. More...
void | SetRadius (const Standard_Real R)
| Changes the radius of the conical surface in the placement plane (Z = 0, V = 0). The local coordinate system is not modified. Raised if R < 0.0. More...
void | SetSemiAngle (const Standard_Real Ang)
| Changes the semi angle of the conical surface. More...
gp_Cone | Cone () const
| returns a non transient cone with the same geometric properties as <me>. More...
Standard_Real | UReversedParameter (const Standard_Real U) const
| return 2.PI - U. More...
Standard_Real | VReversedParameter (const Standard_Real V) const
| Computes the u (or v) parameter on the modified surface, when reversing its u (or v) parametric direction, for any point of u parameter U (or of v parameter V) on this cone. In the case of a cone, these functions return respectively: More...
virtual void | VReverse ()
| Changes the orientation of this cone in the v parametric direction. The bounds of the surface are not changed but the v parametric direction is reversed. As a consequence, for a cone: More...
virtual void | TransformParameters (Standard_Real &U, Standard_Real &V, const gp_Trsf &T) const
| Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>. More...
virtual gp_GTrsf2d | ParametricTransformation (const gp_Trsf &T) const
| Returns a 2d transformation used to find the new parameters of a point on the transformed surface. More...
gp_Pnt | Apex () const
| Computes the apex of this cone. It is on the negative side of the axis of revolution of this cone if the half-angle at the apex is positive, and on the positive side of the "main Axis" if the half-angle is negative. More...
void | Bounds (Standard_Real &U1, Standard_Real &U2, Standard_Real &V1, Standard_Real &V2) const
| The conical surface is infinite in the V direction so V1 = Realfirst from Standard and V2 = RealLast. U1 = 0 and U2 = 2*PI. More...
void | Coefficients (Standard_Real &A1, Standard_Real &A2, Standard_Real &A3, Standard_Real &B1, Standard_Real &B2, Standard_Real &B3, Standard_Real &C1, Standard_Real &C2, Standard_Real &C3, Standard_Real &D) const
| Returns the coefficients of the implicit equation of the quadric in the absolute cartesian coordinate system : These coefficients are normalized. A1.X**2 + A2.Y**2 + A3.Z**2 + 2.(B1.X.Y + B2.X.Z + B3.Y.Z) + 2.(C1.X + C2.Y + C3.Z) + D = 0.0. More...
Standard_Real | RefRadius () const
| Returns the reference radius of this cone. The reference radius is the radius of the circle formed by the intersection of this cone and its reference plane (i.e. the plane defined by the origin, "X Direction" and "Y Direction" of the local coordinate system of this cone). If the apex of this cone is on the origin of the local coordinate system of this cone, the returned value is 0. More...
Standard_Real | SemiAngle () const
| returns the semi-angle of the conical surface ]0.0, PI/2[. More...
Standard_Boolean | IsUClosed () const
| returns True. More...
Standard_Boolean | IsVClosed () const
| returns False. More...
Standard_Boolean | IsUPeriodic () const
| Returns True. More...
Standard_Boolean | IsVPeriodic () const
| Returns False. More...
Handle< Geom_Curve > | UIso (const Standard_Real U) const
| Builds the U isoparametric line of this cone. The origin of this line is on the reference plane of this cone (i.e. the plane defined by the origin, "X Direction" and "Y Direction" of the local coordinate system of this cone). More...
Handle< Geom_Curve > | VIso (const Standard_Real V) const
| Builds the V isoparametric circle of this cone. It is the circle on this cone, located in the plane of Z coordinate V*cos(Semi-Angle) in the local coordinate system of this cone. The "Axis" of this circle is the axis of revolution of this cone. Its starting point is defined by the "X Direction" of this cone. Warning If the V isoparametric circle is close to the apex of this cone, the radius of the circle becomes very small. It is possible to have a circle with radius equal to 0.0. More...
void | D0 (const Standard_Real U, const Standard_Real V, gp_Pnt &P) const
| Computes the point P (U, V) on the surface. P (U, V) = Loc + (RefRadius + V * sin (Semi-Angle)) * (cos (U) * XDir + sin (U) * YDir) + V * cos (Semi-Angle) * ZDir where Loc is the origin of the placement plane (XAxis, YAxis) XDir is the direction of the XAxis and YDir the direction of the YAxis. More...
void | D1 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V) const
| Computes the current point and the first derivatives in the directions U and V. More...
void | D2 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV) const
| Computes the current point, the first and the second derivatives in the directions U and V. More...
void | D3 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV, gp_Vec &D3U, gp_Vec &D3V, gp_Vec &D3UUV, gp_Vec &D3UVV) const
| Computes the current point, the first,the second and the third derivatives in the directions U and V. More...
gp_Vec | DN (const Standard_Real U, const Standard_Real V, const Standard_Integer Nu, const Standard_Integer Nv) const
| Computes the derivative of order Nu in the u parametric direction, and Nv in the v parametric direction at the point of parameters (U, V) of this cone. Exceptions Standard_RangeError if: More...
void | Transform (const gp_Trsf &T)
| Applies the transformation T to this cone. More...
Handle< Geom_Geometry > | Copy () const
| Creates a new object which is a copy of this cone. More...
Public Member Functions inherited from Geom_ElementarySurface
void | SetAxis (const gp_Ax1 &A1)
| Changes the main axis (ZAxis) of the elementary surface. More...
void | SetLocation (const gp_Pnt &Loc)
| Changes the location of the local coordinates system of the surface. More...
void | SetPosition (const gp_Ax3 &A3)
| Changes the local coordinates system of the surface. More...
gp_Ax1 | Axis () const
| Returns the main axis of the surface (ZAxis). More...
gp_Pnt | Location () const
| Returns the location point of the local coordinate system of the surface. More...
const gp_Ax3 & | Position () const
| Returns the local coordinates system of the surface. More...
virtual void | UReverse ()
| Reverses the U parametric direction of the surface. More...
GeomAbs_Shape | Continuity () const
| Returns GeomAbs_CN, the global continuity of any elementary surface. More...
Standard_Boolean | IsCNu (const Standard_Integer N) const
| Returns True. More...
Standard_Boolean | IsCNv (const Standard_Integer N) const
| Returns True. More...
Public Member Functions inherited from Geom_Surface
Handle< Geom_Surface > | UReversed () const
| Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
Handle< Geom_Surface > | VReversed () const
| Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
virtual Standard_Real | UPeriod () const
| Returns the period of this surface in the u parametric direction. raises if the surface is not uperiodic. More...
virtual Standard_Real | VPeriod () const
| Returns the period of this surface in the v parametric direction. raises if the surface is not vperiodic. More...
gp_Pnt | Value (const Standard_Real U, const Standard_Real V) const
| Computes the point of parameter U on the surface. More...
Public Member Functions inherited from Geom_Geometry
void | Mirror (const gp_Pnt &P)
| Performs the symmetrical transformation of a Geometry with respect to the point P which is the center of the symmetry. More...
void | Mirror (const gp_Ax1 &A1)
| Performs the symmetrical transformation of a Geometry with respect to an axis placement which is the axis of the symmetry. More...
void | Mirror (const gp_Ax2 &A2)
| Performs the symmetrical transformation of a Geometry with respect to a plane. The axis placement A2 locates the plane of the symmetry : (Location, XDirection, YDirection). More...
void | Rotate (const gp_Ax1 &A1, const Standard_Real Ang)
| Rotates a Geometry. A1 is the axis of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt &P, const Standard_Real S)
| Scales a Geometry. S is the scaling value. More...
void | Translate (const gp_Vec &V)
| Translates a Geometry. V is the vector of the tanslation. More...
void | Translate (const gp_Pnt &P1, const gp_Pnt &P2)
| Translates a Geometry from the point P1 to the point P2. More...
Handle< Geom_Geometry > | Mirrored (const gp_Pnt &P) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax1 &A1) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax2 &A2) const
Handle< Geom_Geometry > | Rotated (const gp_Ax1 &A1, const Standard_Real Ang) const
Handle< Geom_Geometry > | Scaled (const gp_Pnt &P, const Standard_Real S) const
Handle< Geom_Geometry > | Transformed (const gp_Trsf &T) const
Handle< Geom_Geometry > | Translated (const gp_Vec &V) const
Handle< Geom_Geometry > | Translated (const gp_Pnt &P1, const gp_Pnt &P2) const
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Additional Inherited Members
Protected Attributes inherited from Geom_ElementarySurface
gp_Ax3 | pos

## Detailed Description

Describes a cone. A cone is defined by the half-angle at its apex, and is positioned in space by a coordinate system (a gp_Ax3 object) and a reference radius as follows:

- The "main Axis" of the coordinate system is the axis of revolution of the cone.
- The plane defined by the origin, the "X Direction" and the "Y Direction" of the coordinate system is the reference plane of the cone. The intersection of the cone with this reference plane is a circle of radius equal to the reference radius.
- The apex of the cone is on the negative side of the "main Axis" of the coordinate system if the half-angle is positive, and on the positive side if the half-angle is negative. This coordinate system is the "local coordinate system" of the cone. The following apply:
- Rotation around its "main Axis", in the trigonometric sense given by the "X Direction" and the "Y Direction", defines the u parametric direction.
- Its "X Axis" gives the origin for the u parameter.
- Its "main Direction" is the v parametric direction of the cone.
- Its origin is the origin of the v parameter. The parametric range of the two parameters is:
- [ 0, 2.*Pi ] for u, and - ] -infinity, +infinity [ for v The parametric equation of the cone is: P(u, v) = O + (R + v*sin(Ang)) * (cos(u)*XDir + sin(u)*YDir) + v*cos(Ang)*ZDir where:
- O, XDir, YDir and ZDir are respectively the origin, the "X Direction", the "Y Direction" and the "Z Direction" of the cone's local coordinate system,
- Ang is the half-angle at the apex of the cone, and
- R is the reference radius.

## Constructor & Destructor Documentation

Geom_ConicalSurface::Geom_ConicalSurface | ( | const gp_Ax3 & | A3,
|  | const Standard_Real | Ang,
|  | const Standard_Real | Radius
| ) |  |

A3 defines the local coordinate system of the conical surface. Ang is the conical surface semi-angle ]0, PI/2[. Radius is the radius of the circle Viso in the placement plane of the conical surface defined with "XAxis" and "YAxis". The "ZDirection" of A3 defines the direction of the surface's axis of symmetry. If the location point of A3 is the apex of the surface Radius = 0 . At the creation the parametrization of the surface is defined such that the normal Vector (N = D1U ^ D1V) is oriented towards the "outside region" of the surface.

Raised if Radius < 0.0 or Ang < Resolution from gp or Ang >= PI/2 - Resolution

Geom_ConicalSurface::Geom_ConicalSurface | ( | const gp_Cone & | C | ) |

Creates a ConicalSurface from a non transient Cone from package gp.

## Member Function Documentation

gp_Pnt Geom_ConicalSurface::Apex | ( |  | ) | const

Computes the apex of this cone. It is on the negative side of the axis of revolution of this cone if the half-angle at the apex is positive, and on the positive side of the "main Axis" if the half-angle is negative.

void Geom_ConicalSurface::Bounds | ( | Standard_Real & | U1,
|  | Standard_Real & | U2,
|  | Standard_Real & | V1,
|  | Standard_Real & | V2
| ) |  | const
| virtual

The conical surface is infinite in the V direction so V1 = Realfirst from Standard and V2 = RealLast. U1 = 0 and U2 = 2*PI.

Implements Geom_Surface.

void Geom_ConicalSurface::Coefficients | ( | Standard_Real & | A1,
|  | Standard_Real & | A2,
|  | Standard_Real & | A3,
|  | Standard_Real & | B1,
|  | Standard_Real & | B2,
|  | Standard_Real & | B3,
|  | Standard_Real & | C1,
|  | Standard_Real & | C2,
|  | Standard_Real & | C3,
|  | Standard_Real & | D
| ) |  | const

Returns the coefficients of the implicit equation of the quadric in the absolute cartesian coordinate system : These coefficients are normalized. A1.X**2 + A2.Y**2 + A3.Z**2 + 2.(B1.X.Y + B2.X.Z + B3.Y.Z) + 2.(C1.X + C2.Y + C3.Z) + D = 0.0.

gp_Cone Geom_ConicalSurface::Cone | ( |  | ) | const

returns a non transient cone with the same geometric properties as <me>.

Handle< Geom_Geometry > Geom_ConicalSurface::Copy | ( |  | ) | const
| virtual

Creates a new object which is a copy of this cone.

Implements Geom_Geometry.

void Geom_ConicalSurface::D0 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P
| ) |  | const
| virtual

Computes the point P (U, V) on the surface. P (U, V) = Loc + (RefRadius + V * sin (Semi-Angle)) * (cos (U) * XDir + sin (U) * YDir) + V * cos (Semi-Angle) * ZDir where Loc is the origin of the placement plane (XAxis, YAxis) XDir is the direction of the XAxis and YDir the direction of the YAxis.

Implements Geom_Surface.

void Geom_ConicalSurface::D1 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V
| ) |  | const
| virtual

Computes the current point and the first derivatives in the directions U and V.

Implements Geom_Surface.

void Geom_ConicalSurface::D2 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV
| ) |  | const
| virtual

Computes the current point, the first and the second derivatives in the directions U and V.

Implements Geom_Surface.

void Geom_ConicalSurface::D3 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV,
|  | gp_Vec & | D3U,
|  | gp_Vec & | D3V,
|  | gp_Vec & | D3UUV,
|  | gp_Vec & | D3UVV
| ) |  | const
| virtual

Computes the current point, the first,the second and the third derivatives in the directions U and V.

Implements Geom_Surface.

gp_Vec Geom_ConicalSurface::DN | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | Nu,
|  | const Standard_Integer | Nv
| ) |  | const
| virtual

Computes the derivative of order Nu in the u parametric direction, and Nv in the v parametric direction at the point of parameters (U, V) of this cone. Exceptions Standard_RangeError if:

- Nu + Nv is less than 1,
- Nu or Nv is negative.

Implements Geom_Surface.

Standard_Boolean Geom_ConicalSurface::IsUClosed | ( |  | ) | const
| virtual

returns True.

Implements Geom_Surface.

Standard_Boolean Geom_ConicalSurface::IsUPeriodic | ( |  | ) | const
| virtual

Returns True.

Implements Geom_Surface.

Standard_Boolean Geom_ConicalSurface::IsVClosed | ( |  | ) | const
| virtual

returns False.

Implements Geom_Surface.

Standard_Boolean Geom_ConicalSurface::IsVPeriodic | ( |  | ) | const
| virtual

Returns False.

Implements Geom_Surface.

virtual gp_GTrsf2d Geom_ConicalSurface::ParametricTransformation | ( | const gp_Trsf & | T | ) | const
| virtual

Returns a 2d transformation used to find the new parameters of a point on the transformed surface.

me->Transformed(T)->Value(U',V')

is the same point as

me->Value(U,V).Transformed(T)

Where U',V' are obtained by transforming U,V with th 2d transformation returned by

me->ParametricTransformation(T)

This methods returns a scale centered on the U axis with T.ScaleFactor

Reimplemented from Geom_Surface.

Standard_Real Geom_ConicalSurface::RefRadius | ( |  | ) | const

Returns the reference radius of this cone. The reference radius is the radius of the circle formed by the intersection of this cone and its reference plane (i.e. the plane defined by the origin, "X Direction" and "Y Direction" of the local coordinate system of this cone). If the apex of this cone is on the origin of the local coordinate system of this cone, the returned value is 0.

Standard_Real Geom_ConicalSurface::SemiAngle | ( |  | ) | const

returns the semi-angle of the conical surface ]0.0, PI/2[.

void Geom_ConicalSurface::SetCone | ( | const gp_Cone & | C | ) |

Set <me> so that <me> has the same geometric properties as C.

void Geom_ConicalSurface::SetRadius | ( | const Standard_Real | R | ) |

Changes the radius of the conical surface in the placement plane (Z = 0, V = 0). The local coordinate system is not modified. Raised if R < 0.0.

void Geom_ConicalSurface::SetSemiAngle | ( | const Standard_Real | Ang | ) |

Changes the semi angle of the conical surface.

Raised if Ang < Resolution or Ang >= PI/2 - Resolution

void Geom_ConicalSurface::Transform | ( | const gp_Trsf & | T | ) |
| virtual

Applies the transformation T to this cone.

Implements Geom_Geometry.

virtual void Geom_ConicalSurface::TransformParameters | ( | Standard_Real & | U,
|  | Standard_Real & | V,
|  | const gp_Trsf & | T
| ) |  | const
| virtual

Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>.

me->Transformed(T)->Value(U',V')

is the same point as

me->Value(U,V).Transformed(T)

Where U',V' are the new values of U,V after calling

me->TranformParameters(U,V,T)

This methods multiplies V by T.ScaleFactor()

Reimplemented from Geom_Surface.

Handle< Geom_Curve > Geom_ConicalSurface::UIso | ( | const Standard_Real | U | ) | const
| virtual

Builds the U isoparametric line of this cone. The origin of this line is on the reference plane of this cone (i.e. the plane defined by the origin, "X Direction" and "Y Direction" of the local coordinate system of this cone).

Implements Geom_Surface.

Standard_Real Geom_ConicalSurface::UReversedParameter | ( | const Standard_Real | U | ) | const
| virtual

return 2.PI - U.

Implements Geom_ElementarySurface.

Handle< Geom_Curve > Geom_ConicalSurface::VIso | ( | const Standard_Real | V | ) | const
| virtual

Builds the V isoparametric circle of this cone. It is the circle on this cone, located in the plane of Z coordinate V*cos(Semi-Angle) in the local coordinate system of this cone. The "Axis" of this circle is the axis of revolution of this cone. Its starting point is defined by the "X Direction" of this cone. Warning If the V isoparametric circle is close to the apex of this cone, the radius of the circle becomes very small. It is possible to have a circle with radius equal to 0.0.

Implements Geom_Surface.

virtual void Geom_ConicalSurface::VReverse | ( |  | ) |
| virtual

Changes the orientation of this cone in the v parametric direction. The bounds of the surface are not changed but the v parametric direction is reversed. As a consequence, for a cone:

- the "main Direction" of the local coordinate system is reversed, and
- the half-angle at the apex is inverted.

Reimplemented from Geom_ElementarySurface.

Standard_Real Geom_ConicalSurface::VReversedParameter | ( | const Standard_Real | V | ) | const
| virtual

Computes the u (or v) parameter on the modified surface, when reversing its u (or v) parametric direction, for any point of u parameter U (or of v parameter V) on this cone. In the case of a cone, these functions return respectively:

- 2.*Pi - U, -V.

Implements Geom_ElementarySurface.

The documentation for this class was generated from the following file:

- Geom_ConicalSurface.hxx